INCLUDE \masm32\include\masm32rt.inc
.586
.xmm
INCLUDE \masm32\macros\timers.asm

.data
buf BYTE 30 DUP(0)
val1 DWORD -1		;maximum unsigned value

.code
;  

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ALIGN 16
;udw2str2 by Hutch
udw2str2 proc dwNumber:DWORD, pszString:DWORD
  push ebx
    push esi
    push edi

    mov eax, [esp+4][12]       ; value
    mov esi, [esp+8][12]       ; szbuf

    cmp eax, 9
    ja lb1
    add esi, 1
    jmp nxt
  lb1:
    cmp eax, 99
    ja lb2
    add esi, 2
    jmp nxt
  lb2:
    cmp eax, 999
    ja lb3
    add esi, 3
    jmp nxt
  lb3:
    cmp eax, 9999
    ja lb4
    add esi, 4
    jmp nxt
  lb4:
    cmp eax, 99999
    ja lb5
    add esi, 5
    jmp nxt
  lb5:
    cmp eax, 999999
    ja lb6
    add esi, 6
    jmp nxt
  lb6:
    cmp eax, 9999999
    ja lb7
    add esi, 7
    jmp nxt
  lb7:
    cmp eax, 99999999
    ja lb8
    add esi, 8
    jmp nxt
  lb8:
    cmp eax, 999999999
    ja lb9
    add esi, 9
    jmp nxt
  lb9:
    add esi, 10

  nxt:

    mov ebx, 0CCCCCCCDh
    mov BYTE PTR [esi], 0
    sub esi, 1

  stlp:
    mov ecx, eax
    mul ebx
    shr edx, 3
    mov eax, edx
    lea edx, [edx+edx*4]
    lea edx, [edx+edx]
    sub ecx, edx
    add cl, '0'
    mov [esi], cl
    sub esi, 1
    test eax, eax
    jbe lpqt

    mov ecx, eax
    mul ebx
    shr edx, 3
    mov eax, edx
    lea edx, [edx+edx*4]
    lea edx, [edx+edx]
    sub ecx, edx
    add cl, '0'
    mov [esi], cl
    sub esi, 1
    test eax, eax
    ja stlp

  lpqt:
    pop edi
    pop esi
    pop ebx
    ret 8
udw2str2 endp


;  
ALIGN 16
;u32toalin by lingo
db  11 Dup (0)
u32toalin  PROC, value:DWORD, szbuf:DWORD
	pop		edx	        	
	pop		eax           
	cmp    eax, 99999              
	pop     ecx        
	jbe		L4	
	cmp		eax, 9999999        
	push   edx				
	jbe		L2
	cmp		eax, 999999999    
    push   ebx 	
	ja			L8
	cmp		eax, 99999999     
	ja			L1	
	add	    ecx, 8					 	
	push   esi    
	jne 		L9
L1 :
	add	    ecx, 9
	push   esi							
	jne 		L9
L2:
	cmp		eax, 999999         
	push	ebx
	ja			L3	
	add	    ecx, 6
	push   esi							
	jne 		L9
L3:
	add	    ecx, 7
	push   esi							
	jne 		L9
L4:	
	cmp    eax, 999              
	push   edx        
	jbe		L6
	cmp    eax, 9999              	
	push ebx
	ja		  L5
	add	    ecx, 4
	push   esi							
	jne 		L9
L5:
	add	    ecx, 5
	push   esi							
	jne 		L9
L6:
	cmp    eax, 99			            
	push   ebx
	jbe	 	L7
	add	    ecx, 3
	push   esi							
	jne 		L9
L8:
	push   esi    
	add	    ecx, 10
L9:
	mov	    byte ptr [ecx], 0
	mov     esi,  0CCCCCCCDh
@@:
    mov		ebx, eax
    mul		esi
    shr		edx, 3
    sub		ecx, 1
    mov		eax, edx
    lea		edx, [edx+edx*4]
    lea		edx, [edx+edx-30h]
    sub		ebx, edx
    mov		[ecx], bl
    test		eax, eax
    je		   @f

	mov		ebx, eax
    mul		esi
    shr		edx, 3
    sub		ecx, 1
    mov		eax, edx
    lea		edx, [edx+edx*4]
    lea		edx, [edx+edx-30h]
    sub		ebx, edx
    mov		[ecx], bl
    test		eax, eax
    jne		@b
@@:
    pop		esi	
    mov		eax, ecx
    pop		ebx 
    ret 	
L7:
	cmp    eax, 9			           
	push   esi
	jbe	 	L10
	add	    ecx, 2                     
	jne 		L9
L10:
    add      eax, 30h              
    pop		esi	
	mov		[ecx],  ax
    pop		ebx 
    mov		eax, ecx
    ret 
u32toalin ENDP
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
;----------------------------------------------------------
main PROC
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE udw2str2, val1, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for udw2str2-Hutch",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE u32toalin, val1, ADDR buf
	counter_end
	print ustr$(eax)
	print chr$(" cycles for u32toalin-Lingo",13,10)

	inkey

	exit
main ENDP
END main
K2:
	mov		dword ptr [ecx], 30303030h
	push	esi
	mov		dword ptr [ecx+4], 30303030h
    mov		esi, 0CCCCCCCDh
	lea		ecx, [ecx+9]
	mov		dword ptr [ecx+8-9], 3030h
nxt:
@@:
	mov  ebx, eax
    mul   esi
    shr    edx, 3
    sub   ecx, 1
	neg	  edx

    mov  eax, edx
    lea    edx, [edx+edx*4]

    lea    ebx, [ebx+edx*2+30h]
    neg    eax

    mov   [ecx], bl
    jne	   @b
